// V p ړʃe[uWFl[^

#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <memory.h>
#include <math.h>

#include "dimiConfigLoader.h"

#define SPEED_MAX  64
#define ANGLE_MAX 256

void GenerateDelta(double *stbl, uint8_t *xtbl, uint8_t *ytbl, uint8_t *utbl, uint8_t *vtbl) {
	double rx, ry;
	double ra;
	int x, y;
	int s, a;
	int inx;

	inx = 0;
	for (s = 0; s < SPEED_MAX; s++) {
		for (a = 0; a < ANGLE_MAX; a++) {
			ra = a * 2.0 * M_PI / ANGLE_MAX;
			rx = -sin(ra) * stbl[s];
			ry = -cos(ra) * stbl[s];
			if (rx >= 0) {
				x = (int)(rx*256.0 + 0.5);
			} else {
				x = (int)(rx*256.0 - 0.5);
			}
			if (ry >= 0) {
				y = (int)(ry*256.0 + 0.5);
			} else {
				y = (int)(ry*256.0 - 0.5);
			}

			xtbl[inx] = (x >> 8) & 255;
			ytbl[inx] = (y >> 8) & 255;
			utbl[inx] = (x     ) & 255;
			vtbl[inx] = (y     ) & 255;
			inx++;
		}
	}
}

void WriteBinary(char *path, uint8_t *buf, int size) {
	FILE *fp;

	fp = fopen(path, "wb");
	if (fp) {
		fwrite(buf, sizeof(uint8_t), size, fp);
		fclose(fp);
	}
}

int main(int argc, char *argv[]) {
	uint8_t xtbl[SPEED_MAX*ANGLE_MAX];
	uint8_t ytbl[SPEED_MAX*ANGLE_MAX];
	uint8_t utbl[SPEED_MAX*ANGLE_MAX];
	uint8_t vtbl[SPEED_MAX*ANGLE_MAX];
	uint8_t bin[SPEED_MAX*ANGLE_MAX*4];
	double stbl[SPEED_MAX];
	char buf[256];
	void *conf;
	char *p, *q, *e;
	int s, b, n;
	int r;

	if (argc < 2) {
		printf("Usage: %s <ݒt@C>\n", argv[0]);
		return 1;
	}

	r = DimiConf_Open(&conf, argv[1]);
	if (r) {
		printf("t@CI[vG[: %s\n", argv[1]);
		return 1;
	}

	for (s = 0; s < SPEED_MAX; s++) {
		sprintf(buf, "speed%d", s);
		p = DimiConf_GetString(conf, "", (const char *)buf, (char *)"0.0");
		stbl[s] = strtod(p, &e);
	}

	GenerateDelta(stbl, xtbl, ytbl, utbl, vtbl);

	for (s = 0; s < SPEED_MAX; s++) {
		b = s & 15;
		n = s >> 4;
		memcpy(bin+b*4096+n*1024,     xtbl+s*256, 256);
		memcpy(bin+b*4096+n*1024+256, ytbl+s*256, 256);
		memcpy(bin+b*4096+n*1024+512, utbl+s*256, 256);
		memcpy(bin+b*4096+n*1024+768, vtbl+s*256, 256);
	}

	p = DimiConf_GetString(conf, "", "name0", (char *)"delta0.bin");
	WriteBinary(p, bin+ 0*4096, 4096);
	p = DimiConf_GetString(conf, "", "name1", (char *)"delta1.bin");
	WriteBinary(p, bin+ 1*4096, 4096);
	p = DimiConf_GetString(conf, "", "name2", (char *)"delta2.bin");
	WriteBinary(p, bin+ 2*4096, 4096);
	p = DimiConf_GetString(conf, "", "name3", (char *)"delta3.bin");
	WriteBinary(p, bin+ 3*4096, 4096);
	p = DimiConf_GetString(conf, "", "name4", (char *)"delta4.bin");
	WriteBinary(p, bin+ 4*4096, 4096);
	p = DimiConf_GetString(conf, "", "name5", (char *)"delta5.bin");
	WriteBinary(p, bin+ 5*4096, 4096);
	p = DimiConf_GetString(conf, "", "name6", (char *)"delta6.bin");
	WriteBinary(p, bin+ 6*4096, 4096);
	p = DimiConf_GetString(conf, "", "name7", (char *)"delta7.bin");
	WriteBinary(p, bin+ 7*4096, 4096);
	p = DimiConf_GetString(conf, "", "name8", (char *)"delta8.bin");
	WriteBinary(p, bin+ 8*4096, 4096);
	p = DimiConf_GetString(conf, "", "name9", (char *)"delta9.bin");
	WriteBinary(p, bin+ 9*4096, 4096);
	p = DimiConf_GetString(conf, "", "name10", (char *)"delta10.bin");
	WriteBinary(p, bin+10*4096, 4096);
	p = DimiConf_GetString(conf, "", "name11", (char *)"delta11.bin");
	WriteBinary(p, bin+11*4096, 4096);
	p = DimiConf_GetString(conf, "", "name12", (char *)"delta12.bin");
	WriteBinary(p, bin+12*4096, 4096);
	p = DimiConf_GetString(conf, "", "name13", (char *)"delta13.bin");
	WriteBinary(p, bin+13*4096, 4096);
	p = DimiConf_GetString(conf, "", "name14", (char *)"delta14.bin");
	WriteBinary(p, bin+14*4096, 4096);
	p = DimiConf_GetString(conf, "", "name15", (char *)"delta15.bin");
	WriteBinary(p, bin+15*4096, 4096);

	DimiConf_Close(conf);

	return 0;
}

